<template>
  <v-app
    v-resize="onResize"
    :style="`background-color: ${$vuetify.theme.themes[theme].pageBackground}`"
  >
    <v-main>
      <chart
        :c-l="cL"
        :unit="unit"
        :action-call="actionCall"
        :name="name"
        :top-click="topClick"
        @clrAC="clrAC"
        @clickBack="clickBack"
      />
    </v-main>
  </v-app>
</template>

<script>

// import { patch } from 'kyd-utils';
import chart from './views/Chart';
import { EventBus } from './localUtils/eventBus';

export default {
  name: 'App',
  components: {
    chart,
  },
  data: () => ({
    cL: 'T',
    unit: '',
    actionCall: '',
    topClick: null,
    name: '',
    usr: true,
    windowSize: {
      x: 0,
      y: 0,
    },
    closeOnContentClick: true,
    loading: {
      app: false,
      preferences: false,
    },
    appKey: '',
    navItems: [
      { title: 'All', icon: 'mdi-database' },
      { title: 'Favourites', icon: 'mdi-heart-outline' },
      { title: 'Apps', icon: 'mdi-apps' },
    ],
  }),
  computed: {

    denseTableRows: {
      get() {
        return this.$store.state.app.user.denseRows;
      },
      set(bool) {
        this.updatePreference({ denseRows: bool });
      },
    },

    theme() {
      return (this.$vuetify.theme.isDark) ? 'dark' : 'light';
    },
  },
  mounted() {
    this.onResize();
    // this.goPhasing();
    EventBus.$on('chartClick', (x) => {
      this.cL = 'D';
      this.name = x.name;
      this.actionCall = x.type;
      this.unit = x.unit;
      // console.log('In mount', x);
    });
    EventBus.$on('rptClick', (x) => {
      this.cL = x.cLevel;
      this.name = x.name;
      this.actionCall = x.type;
      this.unit = x.unit;
      // console.log('In mount rptClick', x);
    });
    EventBus.$on('ddClick', (x) => {
      if (x.cLevel === 'T') {
        this.topClick = x.name;
      } else {
        this.topClick = null;
      }
      this.cL = 'D';
      this.name = x.name;
      this.actionCall = x.type;
      this.unit = x.unit;
      // console.log('In mount ddClick', x);
    });
  },
  methods: {
    // ddClick() {
    //   console.log('In App emit detected');
    // },
    // rptClick(p) {
    //   console.log('In App emit detected rptClick- ', p);
    // },
    clickBack() {
      // console.log('In App emit detected - click Back');
      this.cL = 'T';
      this.name = '';
      this.unit = '';
      this.topClick = null;
      this.actionCall = 'reset';
    },
    clrAC() {
      // console.log('clearing ActionCall');
      this.actionCall = '';
    },
    goChart() {
      if (this.$route.name !== 'Chart') this.$router.push({ name: 'Chart' });
    },
    onResize() {
      // console.log('running resize');
      // eslint-disable-next-line
      const payload = { x: self.innerWidth, y: self.innerHeight };
      // eslint-disable-next-line
      this.windowSize = { x: self.innerWidth, y: self.innerHeight };
      // console.log('on resize', payload)
      this.$store.dispatch('app/setViewPort', payload);
    },
  },
};
</script>
